#pragma once
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <tuple>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <cmath>
#include <algorithm>
#include <ranges>



struct Edge {
    std::pair<int, int> nodes;
    int middle_node;

    Edge() = default;
    Edge(int, int);

    Edge operator = (const Edge&);
    bool operator==(const Edge&) const;
    void UpdateMiddleNode(int);
    Edge CreateEdge(int, int);

    friend std::istream& operator >> (std::istream&, Edge&);
    friend std::ostream& operator << (std::ostream&, const Edge&);
};

struct Node {
    int node_id;
    std::array<double, 3> coors;
    bool vertex;

    Node() = default;
    Node(int, const std::array<double, 3>&, bool);
    Node(const Node&);

    friend std::ostream& operator <<(std::ostream&, const Node&);
    friend std::istream& operator >>(std::istream&, Node&);
};

struct FiniteElement {
    int element_id;
    int material_id;
    std::vector<int> nodes_id;
    FiniteElement() = default;
    FiniteElement(int, int, const std::vector<int>&);

    friend std::ostream& operator<<(std::ostream&, const FiniteElement&);
    friend std::istream& operator>>(std::istream&, FiniteElement&);
};

struct BoundaryFiniteElement {
    int surface_id;
    int element_id;
    
    std::vector<int> nodes_id;
    BoundaryFiniteElement() = default;
    BoundaryFiniteElement(int, int, const std::vector<int>&);

    friend std::ostream& operator<<(std::ostream&, const BoundaryFiniteElement&);
    friend std::istream& operator>>(std::istream&, BoundaryFiniteElement&);
};


