#include "MeshLoader.h"
#include "AneuMeshLoader.h"
#include "Exceptions.h"
#include "DataStructures.h"
#include "HashCustom.h"
#include <iostream>
#include <string>
#include <fstream>
#include <algorithm>
#include <ranges>


//!!! Заданеи на защиту (не удалять)
//!!! Реализовать на основе std::ranges
//!!! 1. Создать контейнер всех граничных элементов (треугольников)
//!!! 2. Отсортировать данный контейнер по площадям.
//!!! 3. С помощью потокового итератора вывести в файл списки узлов элементов с 10 по 20.




int main(int argc, char* argv[]) {
	
	MeshLoader* meshLoader = new AneuMeshLoader; 
	meshLoader->LoadMesh("extrusion.aneu");

	std::vector<Node> nodes = meshLoader->Get_Node();
	

	std::vector<FiniteElement> finiteElements = meshLoader->Get_Finite_Elements();
	std::vector<BoundaryFiniteElement> boundaries = meshLoader->Get_Boundary();

	std::vector<int> elementsByID = meshLoader->Get_Elements_By_ID(1, 2, 3);
	
	std::vector<int> elementsByMaterial = meshLoader->Get_Elements_By_Material(1);
	
	std::vector<int> elementsByEdge = meshLoader->Get_Elements_By_Edge(1, 2);

	std::set<int> nodesBySurface = meshLoader->Get_Nodes_By_Surface(1);

	std::vector<int> boundaryBySurface = meshLoader->Get_Boundary_By_Surface(2);

	meshLoader->Insert_Middle_Nodes();

	auto adjacentNodes = meshLoader->Get_Adjacent_Nodes();
	
	
	return 0;
}